/*
MDCubeRowsC : Implementation of the CubeRows interface for the MS SQL server
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package cube;
import com.ms.com.*;
import msado15.*;
import msado21.*;
import msadomd.*;
import stdole2.*;

public class MDCubeRowsC implements util.CubeRows 
{
	msadomd.CubeDef Cb;
	msadomd.Cellset cSet;
	com.ms.com.SafeArray idx=new SafeArray(Variant.VariantVariant,2);
	int index,j=-1;
	boolean flag=false;
	String emptyString="";
	util.Term inpTerm;
	
	public MDCubeRowsC(msadomd.CubeDef cb,msadomd.Cellset cst,util.Term t) {
	//	util.TimeKeeper t2=new util.TimeKeeper("Total");
		Cb=cb;
		cSet=cst;
		index=-1; 
		inpTerm=t;
		Object ob12;
	//	int k=0;
		while (next()) {
	//		k++;
	//	}
	//	System.out.println(k);
			for (int i=0;i<t.size()+1;i++) {
	//			util.TimeKeeper tk=new util.TimeKeeper("GetObject "+i);
				ob12=getObject(i+1);
//				System.out.println(i+" "+ob12.toString());
	//			tk.stop();
//				System.out.println(tk.toString());
			}
		}
	//	t2.stop();
	//	System.out.println(t2.toString());
		j=-1;
		index=-1;
	}
	
	public Object getParent(util.AttrDesc desc, Object attrId, int parLvl)  throws Exception {
	int lvl=mslevel(desc);
	int dimIndex=desc.dim();
	msadomd.Member mbr=((msadomd.Member)attrId).getParent();
	for (int i=1; i<parLvl; i++) {
	    mbr=mbr.getParent();
	}
	return mbr;	   
    }
	
	public Object getInternalId(util.AttrDesc desc,String Name) {
		try {
		   return getInternalId(desc.dim(),desc.level(),Name);
		} catch (Exception e) {e.printStackTrace(); }
		return null;
	}
	
	public Object getInternalId(int dimIndex, int lvl, String MemberName) throws DataCubeException {
		lvl=mslevel(dimIndex,lvl);
		msadomd.Members mbrs=Cb.getDimensions().getItem(new Variant(dimIndex)).getHierarchies().getItem(new Variant(0)).getLevels().getItem(new Variant(lvl)).getMembers();  
		int nmbrs=mbrs.getCount();		
		for (int i=0; i<nmbrs; i++) {
		    msadomd.Member mem = mbrs.getItem(new Variant(i));
			if (mem.getName().equals(MemberName)) {
				return mem;
		    }
		}
		return null;
	}
	
	public int mslevel(int dimIndex, int lvl) {
	    int totalLevels=Cb.getDimensions().getItem(new Variant(dimIndex)).getHierarchies().getItem(new Variant(0)).getLevels().getCount()-1;
		int mslvl=totalLevels-lvl;
		return mslvl;
	}
	
	public int mslevel(util.AttrDesc desc) {
		return mslevel(desc.dim(), desc.level());
	}
	
	public Object getObject(int i) {
		i--;
		if (i != inpTerm.size()) {
			if (inpTerm.aggregated(i)) {
				if ((i==0) || (inpTerm.desc(i-1).dim() != inpTerm.desc(i).dim())) {
					j++;
				}
				return inpTerm.val(i);
			}
		
			if (inpTerm.constant(i)) {
				if ( (i+1<inpTerm.size()) && ( (inpTerm.desc(i).dim()!=inpTerm.desc(i+1).dim()) || (inpTerm.aggregated(i+1)))) {
				j++;
				}
				return inpTerm.val(i); 
				
			}
			
			if ((i==inpTerm.size()-1) || (!inpTerm.range(i+1)) || (inpTerm.desc(i+1).dim() != inpTerm.desc(i).dim())) {
				return getObjectInt(++j);
			} else {
				int dep=1;
				while ((i+dep<inpTerm.size()) && inpTerm.desc(i).dim()==inpTerm.desc(i+dep).dim()) {
					if (inpTerm.constant(i+dep)) {
						try {
							return ((msadomd.Member)getParent(inpTerm.desc(i+dep),(msadomd.Member)getInternalId(inpTerm.desc(i+dep),(String)getObjectInt(j+1)),dep)).getCaption(); 
						} catch (Exception e) {e.printStackTrace(); }
						return null;
					} 
					if (inpTerm.aggregated(i+dep)) {
						try {
							return ((msadomd.Member)getParent(inpTerm.desc(i+dep),(msadomd.Member)getInternalId(inpTerm.desc(i+dep-1),(String)getObjectInt(j+1)),dep-1)).getCaption();
						} catch (Exception e) {e.printStackTrace(); }
						return null;
  					} 
					dep++;
				}
				dep--;
				try {
					return ((msadomd.Member)getParent(inpTerm.desc(i+dep),(msadomd.Member)getInternalId(inpTerm.desc(i+dep),(String)getObjectInt(j+1)),dep)).getCaption();
				}catch (Exception e) {e.printStackTrace(); }
				return null;
				
			}
		} else {
			flag=true;
			return getObjectInt(++j); 
		}
		
	}
	
	public Object getObjectInt(int i) {
//		System.out.println(i);
		idx.fromIntArray(new int[]{0,index}); 
		if (!flag) {  	
			return cSet.getItem(idx).getPositions().getItem(new Variant(1)).getMembers().getItem(new Variant(i)).getCaption();
			
		} else {
			if (cSet.getItem(idx).getValue() != null)
				return cSet.getItem(idx).getValue(); // new Float((cSet.getItem(idx).getValue()).toFloat());
			else
				return emptyString;
		}
	}
	
	public boolean next() {
		index++;
		idx.fromIntArray(new int[]{0,index}); 
		try {
			String tmp=cSet.getItem(idx).getFormattedValue();
		} catch (com.ms.com.ComFailException e) {return false;}
		j=-1;
		flag=false;
		return true;
	}

    public int numColumns() {
		return inpTerm.size()+1; 
    }
	
	public void close() {
		System.out.println("Cursor closed..");
		cSet.Close();}	
}
