/*
OracleDB : Provides database functionality for Oracle
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package cube;

import util.*;
import java.sql.*;

public class OracleDB extends DB {
    static {
	try {

	    // register the driver with DriverManager
	    DriverManager.registerDriver((Driver)Class.forName("oracle.jdbc.driver.OracleDriver").newInstance());
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }	
    OracleDB(String dbname, String userid, String passwd, boolean debug) throws SQLException {
	super();
	_dbname = dbname;

	String url = "jdbc:oracle:thin:@" + dbname;
	// con = DriverManager.getConnection(url);
	// connect with user-provided username and password
	con = DriverManager.getConnection(url, userid, passwd);
	_debug = debug;
	MyOut.println("Connect to database " + url);
    }

    public String dbType() { return "Oracle";}
    public void createTempTable1(String tabname, String schema) throws Exception  {
	executeUpdate("create global temporary table " + tabname + schema + " on commit delete rows"); 
    }
    public void createUnloggedTable(String tabname, String schema) throws Exception  {
	executeUpdate("create table " +  tabname + schema); // + " nologging ");
    }
    public String nullFilter() {
	return "NVL";
    }

};
