/*
RelCube : Enhanced functions on top of the data cube
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package cube;

import java.util.*;
import java.sql.*;

import util.*;

public interface RelCube extends Cube {
    public DB db();
    public String dbName();
    public String colName(int i, int j);
    public String relName();
    public ResultSet subCube(Term t, boolean sorted) throws SQLException;
    public ResultSet subCube(Term t) throws SQLException;
    public String mergedSubCubeQuery(Term t1, Term t2) throws SQLException; 
    public String subCubeQuery(Term t, String desiredMeas);
    public String subCubeQuery(Term t, String desiredMeas, Vector exclTerms);
}
