/*
RelCubeRows : Accessing tuples contained in the query result
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package cube;

import util.*;
import java.util.*;
import java.sql.*;

public class RelCubeRows implements CubeRows {
    int numCols;
    ResultSet rs;
    TermDesc tdesc;
    RelCubeRows(ResultSet resultSet, TermDesc termDesc) throws Exception {
	// Get all rows.
	numCols = resultSet.getMetaData().getColumnCount();
	rs = resultSet;
	tdesc = termDesc;
    }
    public boolean next() throws Exception {
	if (rs == null)
	    return false;
	boolean retVal = rs.next();
	if (! retVal)
	    close();
	return retVal; 
    }
    public AttrDesc colDesc(int i) {
	return tdesc.desc(i);
    }
    public int numColumns() {
	return numCols;
    }
    public double getDouble(int i) throws Exception {
	return rs.getDouble(i);
    }
    public Object getObject(int i) throws Exception {
	if (rs == null)
	    return null;
	if ((i < 1) || (i > numCols))
	    return null;
	return rs.getObject(i);
    }
    public void close() {
	if (rs == null)
	    return;
	DB.cursorClose(rs);
	rs = null;
    }
}
