/*
BooleanError : Calculates error depending on the boolean condition of a tuple's ratio being greater/lesser than 1
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package diff;


public class BooleanError extends Alg {
    int numDerived()  {return 2;}
    public void calcDerivedCols(double _v1, double _v2, double _dvals[]) {
	_dvals[0] = (_v1 < _v2)?1:0;
	_dvals[1] = (_v1 > _v2)?1:0;
    }
    public double error(double _v1, double _v2, int cnt, double _dvals[], double r) {
	if (r > 1)  			//if parent ratio >1
	    return _dvals[1];		//return #children with ratio <1
	return _dvals[0];
    }
}
