/*
<one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 19yy  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package diff;
import cube.*;
import util.*;

public class ResultStore {
    public ResultStore(Result res, RelCube c) {
	if (res.numTups() <= 0) return;
	Tuple t = (Tuple)res.tup(0);
	DB db = c.db();
	
	String tabname = "tempRes";
	db.dropTable(tabname);
	try {
	String crstr = "CREATE TABLE " + tabname + "(" ;
	for (int i = 0; i < t.numAttrs(); i++)
	    crstr += (c.attrName(t.desc(i).dim(), t.desc(i).level()) + " varchar(50), ");
	String val1 = "Actual", val2 = "Expected";
	crstr += (val1 + " float, " + val2 + " float, count int, "); 
	crstr += "ratio float)";  // , error float
	db.executeUpdate(crstr);

	for (int i = 0; i < res.numTups(); i++) {
	    String strst = "insert into " + tabname + " values( " ;
	    for (int dd = 0; dd < t.numAttrs(); dd++) {
		strst += ("'" + res.tup(i).getExternalName(c, dd)  + "', ");
	    }
	    strst += (res.tup(i)._v1 + ", "
		      + (res.tup(i)._v2) + ", "
		      + (((Tuple)res.tup(i))._cnt) + ", "
		      + (res.tup(i).ratio())
		      // + ", " + mapToString(res.tup(i).cost())
		      //+ mapToString(res.tup(i).squareError(res.tup(i).ratio()))
		       + ")");
	    db.executeUpdate(strst);
	}
	}  catch(Exception e) {
	    e.printStackTrace();
	}
    }
}
