/*
ICubeApplet : Initialization of the ICubeServer through an Applet
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package frontend;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import java.applet.*;

public class ICubeApplet extends JApplet {
    JPanel panel;
    
    public void init() {

        String vers = System.getProperty("java.version");
        final Applet thisApplet = this;

        if (vers.compareTo("1.1.2") < 0) {
            System.out.println("!!!WARNING: Swing must be run with a " +
                               "1.1.2 or higher version VM!!!");
        }

	// Force SwingSet to come up in the Cross Platform L&F
	try {
	    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	    // If you want the System L&F instead, comment out the above line and
	    // uncomment the following:
	    // UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	} catch (Exception exc) {
	    System.err.println("Error loading L&F: " + exc);
	}

        panel = new JPanel();
        getContentPane().add(panel,BorderLayout.CENTER);
        panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));

	/*
        JPanel progressPanel = SwingSet.createVerticalPanel(false);
        panel.add(Box.createGlue());
        panel.add(progressPanel);
        panel.add(Box.createGlue());
        progressPanel.add(Box.createGlue());

        Dimension d = new Dimension(400, 20);
        ICubeFront.progressLabel = new JLabel("Loading, please wait...");
        ICubeFront.progressLabel.setMaximumSize(d);
        progressPanel.add(ICubeFront.progressLabel);
        progressPanel.add(Box.createRigidArea(new Dimension(1,20)));

        ICubeFront.progressBar = new JProgressBar();
        ICubeFront.progressBar.setMaximumSize(d);
        ICubeFront.progressBar.setMinimum(0);
        ICubeFront.progressBar.setMaximum(ICubeFront.totalPanels);
        ICubeFront.progressBar.setValue(0);
        progressPanel.add(ICubeFront.progressBar);
        progressPanel.add(Box.createGlue());
        progressPanel.add(Box.createGlue());
	*/
	
	/*
        // show the panel
        Rectangle ab = getContentPane().getBounds();
        panel.setPreferredSize(new Dimension(ab.width,ab.height));
        getContentPane().add(panel,BorderLayout.CENTER);
        validate();
        setVisible(true);


	
        ICubeFront cubefront = new ICubeFront(thisApplet);

        getContentPane().remove(panel);
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(cubefront, BorderLayout.CENTER);
        validate();
        repaint();
        cubefront.requestDefaultFocus();
	*/
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {thisApplet.stop();}
	};
	String s = getParameter("UserName");
	if (s != null)
	    ICubeFront.DefaultUserName = s;
	s = getParameter("Password");
	if (s != null)
	    ICubeFront.DefaultPassword = s;
	s = getParameter("Server");
	if (s != null)
	    ICubeFront.DefaultServer = s;
	s = getParameter("CubeName");
	if (s != null)
	    ICubeFront.DefaultCubeName = s;

	ICubeFront.createCubeFront(thisApplet,l);
    }
}


