package frontend;
import cube.*;
import main.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.colorchooser.*;
import javax.swing.filechooser.*;
import javax.accessibility.*;
import javax.swing.table.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import java.io.*;
import java.applet.*;
import java.net.*;

public class ICubeFront extends JPanel {
    public static int WIDTH = 790;
    public static int HEIGHT = 550;
    public static int INITIAL_WIDTH = 400;
    public static int INITIAL_HEIGHT = 200;
    public static int MAX_MEMBERS = 100; // maximum number of members per level allowed.
    public final static Insets insets0 = new Insets(0,0,0,0);
    public static String DefaultUserName = "dbuser"; //"nishant";
    public static String DefaultPassword = "student"; //"icube";
    // public static String DefaultServer = "iCubeServer"; // "//quark.it.iitb.ernet.in/iCubeServer";
    public static String DefaultServer = "iCubeServer";
    public static String DefaultCubeName = "data/pp";
    public static String DefaultProvider = "DB2"; //"Oracle";

    // The Frame
    public static JFrame frame;
    JToolBar toolBar;
    JMenuBar menuBar;
    java.applet.Applet applet = null;

    ICubeServer icubeserver = null;
    Cube cube;
    ICubeState cubeState;
    
    static String[] ConnectOptionNames = { "Connect" };
    JPanel connectionPanel;
    JTextField userNameField, passwordField, serverField, cubeField;
    JComboBox providerField;

    JPanel cubePanel;
    JPanel otherPanel;
    ICubeOps cubeOps;
    boolean separateDimPanel = false;
  
    ICubeState getCubeState() {return cubeState;}
    ICubeServer getCubeServer() {return icubeserver;}
    void openCube(String usrName, String usrPasswd, String cubeName, String provider) {
	try {
	    if (icubeserver == null) {
		icubeserver = Access.getICubeServer(serverField.getText(), (applet != null)); 
	    }
	    if (cube != null) {
		closeCube();
		cubeOps.close();
	    }
	    cube = icubeserver.newCube(cubeName,usrName,usrPasswd, provider);
	    CubeViewer cubeViewer = new CubeViewer();
	    // initialize the cube's state.
	    cubeState = new ICubeState(icubeserver, cube, cubeViewer);
	    if (!separateDimPanel) {
		cubePanel.add(createDimPanel(), BorderLayout.NORTH);
	    } else {
		JFrame dframe = newJFrame("Dimensions");
		dframe.getContentPane().add(createSeparateDimPanel());
		dframe.pack();
	    }
	    cubePanel.add(new JScrollPane(cubeViewer), BorderLayout.CENTER);
	    cubeState.fetchData();

	} catch (Exception e) {
	    e.printStackTrace();
	    JOptionPane.showMessageDialog(ICubeFront.this, e.getMessage());
	}
    }
    void closeCube() {
	cubePanel.removeAll();
    }
    class AttrComboBox extends JComboBox {
	int dim;
	int level;
	int attrNum;
	AttrComboBox(int d, int lvl, int num) {
	    super(); dim = d; level = lvl; attrNum = num;
	}
    };

    JPanel createDimPanel() {
	// Now display the cube's dimensions.
	// JPanel dimPanel = new JPanel(new GridLayout(1, cube.numDims()));
	
	int numAttrs = cube.numAttrs();
	int numCols = 3;
	int numRows = (numAttrs+numCols-1)/numCols;
	JPanel dimPanel = new JPanel();
	dimPanel.setLayout(new BoxLayout(dimPanel, BoxLayout.X_AXIS));
	JPanel labelPanel = null;
	JPanel selectPanel = null;

	int attrNum = 0;
	for (int dim = 0; dim < cube.numDims(); dim++) {
	    for (int lvl =  cube.numLevels(dim)-1; lvl >= 0; lvl--, attrNum++) {
		AttrComboBox members = new AttrComboBox(dim,lvl,attrNum);
		cubeState.setMembers(members, attrNum, dim, lvl);
		members.setAlignmentX(LEFT_ALIGNMENT);
		members.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			    AttrComboBox attr = (AttrComboBox)e.getSource();
			    cubeState.registerChange(attr.attrNum, attr.dim, attr.level,
						     attr.getSelectedIndex());
			}
		    });
		
		
		if ((labelPanel == null) || (labelPanel.getComponentCount() == numRows)) {
		    if (labelPanel != null) {
			dimPanel.add(labelPanel);
			dimPanel.add(selectPanel);
		    }
		    labelPanel = new JPanel(new GridLayout(numRows, 1));
		    selectPanel = new JPanel(new GridLayout(numRows, 1));
		}
		String dlabel = cube.attrName(dim,lvl);
		JLabel dimLabel = new JLabel(dlabel, JLabel.LEFT);
		dimLabel.setBorder(BorderFactory.createEtchedBorder());
		labelPanel.add(dimLabel);
		selectPanel.add(members);
	    }
	}
	if (labelPanel != null) {
	    dimPanel.add(labelPanel);
	    dimPanel.add(selectPanel);
	}
	return dimPanel;
    }

    JPanel createSeparateDimPanel() {
	// Now display the cube's dimensions.
	// JPanel dimPanel = new JPanel(new GridLayout(1, cube.numDims()));
	
	int numAttrs = cube.numAttrs();
	int numCols = 1;
	JPanel dimPanel = new JPanel();
	//	dimPanel.setLayout(new BoxLayout(dimPanel, BoxLayout.X_AXIS));
	dimPanel.setLayout(new GridLayout(1,2));
	JPanel labelPanel = null;
	JPanel selectPanel = null;

	int attrNum = 0;
	int numRows = cube.numAttrs()+cube.numDims();
	labelPanel = new JPanel(new GridLayout(numRows, 1));
	selectPanel = new JPanel(new GridLayout(numRows, 1));

	dimPanel.add(labelPanel);
	dimPanel.add(selectPanel);
	labelPanel.setBorder(BorderFactory.createEtchedBorder());
	selectPanel.setBorder(BorderFactory.createEtchedBorder());
	for (int dim = 0; dim < cube.numDims(); dim++) {
	    // add seperator..
	    labelPanel.add(new JLabel(""));
	    selectPanel.add(new JLabel(""));
	    for (int lvl =  cube.numLevels(dim)-1; lvl >= 0; lvl--, attrNum++) {
		AttrComboBox members = new AttrComboBox(dim,lvl,attrNum);
		cubeState.setMembers(members, attrNum, dim, lvl);
		members.setAlignmentX(LEFT_ALIGNMENT);
		members.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			    AttrComboBox attr = (AttrComboBox)e.getSource();
			    cubeState.registerChange(attr.attrNum, attr.dim, attr.level,
						     attr.getSelectedIndex());
			}
		    });		
		String dlabel = cube.attrName(dim,lvl);
		JLabel dimLabel = new JLabel(dlabel, JLabel.LEFT);
		labelPanel.add(dimLabel);
		selectPanel.add(members);
	    }
	}
	return dimPanel;
    }


    JPanel createMenus() {
	JPanel p = new JPanel();
	p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
	menuBar = createMenuBar();
	p.add(menuBar);
	toolBar = createToolBar(); 
	p.add(toolBar); 
	return p;
    }

    JMenuBar createMenuBar() {
	JMenuBar menuBar = new JMenuBar();
	menuBar.setAlignmentX(LEFT_ALIGNMENT);
	menuBar.setAlignmentY(TOP_ALIGNMENT);

	JMenuItem mi;

	// File Menu
	JMenu file = (JMenu) menuBar.add(new JMenu("Cube"));
        file.setMnemonic('C');

	mi = (JMenuItem) file.add(new JMenuItem("Connect"));
        mi.setMnemonic('C');
	mi.getAccessibleContext().setAccessibleDescription("Connect to server");
	mi.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		activateConnectionDialog();
	    }
	});

	
	/*        mi = (JMenuItem) file.add(new JMenuItem("Open"));
        mi.setMnemonic('O');
	mi.getAccessibleContext().setAccessibleDescription("Opening a cube");
	mi.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String result = JOptionPane.showInputDialog(ICubeFront.this, "Cube name:");
		if(result != null) {
		    openCube(result);
		    //	JOptionPane.showMessageDialog(ICubeFront.this, message);
		}
	    }
	});
	*/
        mi = (JMenuItem) file.add(new JMenuItem("Close"));
        mi.setMnemonic('C');
	mi.getAccessibleContext().setAccessibleDescription("Closing cube");
	
        file.addSeparator();
        mi = (JMenuItem) file.add(new JMenuItem("Exit"));
        mi.setMnemonic('x');
	mi.getAccessibleContext().setAccessibleDescription("Exit");
	mi.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		if (applet == null)
		    System.exit(0);
		else
		    applet.stop();
	    }
	} );
	return menuBar;
    }


    public static ImageIcon loadImageIcon(String filename, String description, Applet applet) {
	if(applet == null) {
	    return new ImageIcon(filename, description);
	} else {
	    URL url;
	    try {
		url = new URL(applet.getCodeBase(),filename);
	    } catch(MalformedURLException e) {
		System.err.println("Error trying to load image " + filename);
		return null;
	    }
	    return new ImageIcon(url, description);
	}
    }


    public static JButton addTool(JToolBar toolBar, String name, boolean text, Applet applet) {
	JButton b;
	if (!text) {
           b = (JButton) toolBar.add(
               new JButton(loadImageIcon("images/" + name + ".gif",name, applet)));
	   // b.setPreferredSize(new Dimension(50,50));
	} else {
	    b = (JButton) toolBar.add(new JButton(name));
	}
	// 
	b.setToolTipText(name);
	b.setMargin(insets0);
	b.getAccessibleContext().setAccessibleName(name);
	toolBar.addSeparator( new Dimension(3,3) );
	return b;
    }

    public static JButton addTool(JToolBar toolBar, String name, Applet applet) {
	return addTool(toolBar, name, false, applet);
    }

    JToolBar createToolBar() {
	JToolBar toolBar = new JToolBar();
	toolBar.setAlignmentX(LEFT_ALIGNMENT);
	toolBar.setAlignmentY(TOP_ALIGNMENT);

	JButton mi;
	mi = addTool(toolBar, "open", applet);
	mi.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		activateConnectionDialog();
	    }
	});
	addTool(toolBar, "close", applet);
	return toolBar;
    }
    
   void activateConnectionDialog() {
	if (JOptionPane.showOptionDialog(ICubeFront.this, connectionPanel, "Connection information",
		   JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
					null, ConnectOptionNames, ConnectOptionNames[0]) == 0) {
	    openCube(userNameField.getText(), passwordField.getText(), cubeField.getText(), (String)providerField.getSelectedItem());
	    if (frame != null) 
		frame.setVisible(true);
	}  else { // if(!frame.isVisible())
	    JOptionPane.showMessageDialog(ICubeFront.this, "Cannot open cube");
	}
   }
    
    public void createConnectionDialog() {
 	// Create the labels and text fields.
	JLabel userNameLabel = new JLabel("User name: ", JLabel.RIGHT);
 	userNameField = new JTextField(DefaultUserName); 

	JLabel passwordLabel = new JLabel("Password: ", JLabel.RIGHT);
	passwordField = new JTextField(DefaultPassword); 

        JLabel serverLabel = new JLabel("CubeServer: ", JLabel.RIGHT);
	serverField = new JTextField(DefaultServer); 

	JLabel cubeLabel = new JLabel("CubeName: ", JLabel.RIGHT);
	cubeField = new JTextField(DefaultCubeName); 

	JLabel providerLabel = new JLabel("Provider: ", JLabel.RIGHT);
	providerField = new JComboBox();
	providerField.setEditable(true);
	providerField.addItem("Oracle");
	providerField.addItem("DB2");
	providerField.addItem("MSOLAP;data source=localhost;Initial Catalog=FoodMart 2000");
	providerField.addItem("MSOLAP;data source=fornax;Initial Catalog=FoodMart");
	providerField.setSelectedItem(DefaultProvider);  

	connectionPanel = new JPanel(false);
	connectionPanel.setLayout(new BoxLayout(connectionPanel,
						BoxLayout.X_AXIS));

	JPanel namePanel = new JPanel(false);
	namePanel.setLayout(new GridLayout(0, 1));
	namePanel.add(userNameLabel);
	namePanel.add(passwordLabel);
	namePanel.add(serverLabel);
	namePanel.add(cubeLabel);
	namePanel.add(providerLabel);

	JPanel fieldPanel = new JPanel(false);
	fieldPanel.setLayout(new GridLayout(0, 1));
	fieldPanel.add(userNameField);
	fieldPanel.add(passwordField);
	fieldPanel.add(serverField);
        fieldPanel.add(cubeField);
        fieldPanel.add(providerField);

	connectionPanel.add(namePanel);
	connectionPanel.add(fieldPanel);
    }
    
    public ICubeFront() {
	this(null);
    }
    public ICubeFront(java.applet.Applet anApplet) {
	super(true);
	applet = anApplet;
	createConnectionDialog();
	
        // add menu for opening and closing cube..
	setLayout(new BorderLayout()); // BoxLayout(this, BoxLayout.Y_AXIS));	
	add(createMenus(), BorderLayout.NORTH);

	cubePanel = new JPanel(new BorderLayout()); // new BoxLayout());
	otherPanel = new JPanel();
	activateConnectionDialog();
	JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, cubePanel,
                                   otherPanel);
	add(splitPane, BorderLayout.CENTER);
	cubeOps = new ICubeOps(cubePanel, otherPanel, toolBar, menuBar, this);
	// splitPane.setDividerLocation((double)0.6);
	splitPane.setDividerLocation(200);
    }

    public static void main(String[] args) {
        String vers = System.getProperty("java.version");
        if (vers.compareTo("1.1.2") < 0) {
            System.out.println("!!!WARNING: Swing must be run with a " +
                               "1.1.2 or higher version VM!!!");
        }

	// Force ICubeFront to come up in the Cross Platform L&F
	try {
	    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	    //create default font objects..
	    
	    // install using UImanager..
	    
	    // If you want the System L&F instead, comment out the above line and
	    // uncomment the following:
	    // UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	} catch (ArrayIndexOutOfBoundsException e) {
	    System.err.println("Caught ArrayIndexOutOfBoundsException: " +
			       e.getMessage());
	    e.printStackTrace();
	}  catch (Exception exc) {
	    System.out.println("Error loading L&F: " + exc);
	} 
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	};
	createCubeFront(null,l);
    }

    public JFrame newJFrame(String name) 
    {
	JFrame fr = new JFrame(name);
	fr.setVisible(true);
	// fr.pack();
	return fr;
    }
    public static void createCubeFront(java.applet.Applet anApplet, WindowListener l) 
    {
	frame = new JFrame("ICubeFront");
	frame.addWindowListener(l);
	frame.getAccessibleContext().setAccessibleDescription("A sample application to demonstrate the Swing UI components");

	JOptionPane.setRootFrame(frame);

	Dimension d = new Dimension(400, 20);

	// show the frame
	frame.setSize(INITIAL_WIDTH, INITIAL_HEIGHT);
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	frame.setLocation(screenSize.width/2 - INITIAL_WIDTH/2,
			  screenSize.height/2 - INITIAL_HEIGHT/2);
	frame.show();

        frame.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

	ICubeFront sw = new ICubeFront(anApplet);
	frame.getContentPane().removeAll();
	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().add(sw, BorderLayout.CENTER);
	frame.setLocation(screenSize.width/2 - WIDTH/2,
			  screenSize.height/2 - HEIGHT/2);

	frame.setSize(WIDTH, HEIGHT);
	frame.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

	frame.validate();
	frame.repaint();
        sw.requestDefaultFocus();
    }
};


class ColumnLayout implements LayoutManager {

  int xInset = 5;
  int yInset = 5;
  int yGap = 2;

  public void addLayoutComponent(String s, Component c) {}

  public void layoutContainer(Container c) {
      Insets insets = c.getInsets();
      int height = yInset + insets.top;

      Component[] children = c.getComponents();
      Dimension compSize = null;
      for (int i = 0; i < children.length; i++) {
	  compSize = children[i].getPreferredSize();
	  children[i].setSize(compSize.width, compSize.height);
	  children[i].setLocation( xInset + insets.left, height);
	  height += compSize.height + yGap;
      }

  }

  public Dimension minimumLayoutSize(Container c) {
      Insets insets = c.getInsets();
      int height = yInset + insets.top;
      int width = 0 + insets.left + insets.right;

      Component[] children = c.getComponents();
      Dimension compSize = null;
      for (int i = 0; i < children.length; i++) {
	  compSize = children[i].getPreferredSize();
	  height += compSize.height + yGap;
	  width = Math.max(width, compSize.width + insets.left + insets.right + xInset*2);
      }
      height += insets.bottom;
      return new Dimension( width, height);
  }

  public Dimension preferredLayoutSize(Container c) {
      return minimumLayoutSize(c);
  }

  public void removeLayoutComponent(Component c) {}

}
