/*
MyTable : Extends the JTable to customize certain parameters
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package frontend;
import javax.swing.*;
import javax.swing.table.*;

class MyTable extends JTable {
    public MyTable() {
	super();
	init();
    }
    public MyTable(AbstractTableModel m) {
	super(m);
	init();
    }
    private void init() {
	setCellSelectionEnabled(true);
	setRowSelectionAllowed(true);
	setColumnSelectionAllowed(true);
	getTableHeader().setReorderingAllowed(false);
	getTableHeader().setResizingAllowed(true);
    }

    /*
    private void initColumnSizes(JTable table, CubeModel model) {
        TableColumn column = null;
        Component comp = null;
        int headerWidth = 0;
        int cellWidth = 0;

        for (int i = 0; i < model.getColumnCount(); i++) {
	    Object longObject = model.getValueAt(0,i);
	    int maxlen = 0;
	    if (i < colStart) {
		for (int r = 0; r < model.getRowCount(); r++) {
		    if (getValueAt(r,i) == null)
			continue;
		    int len = getValueAt(r,i).toString().length();
		    if (len > maxlen) {
			longObject = getValueAt(r,i);
			maxlen = len;
		    }
		}
	    } 
	    
	    column = table.getColumnModel().getColumn(i);

            comp = column.getHeaderRenderer().
                             getTableCellRendererComponent(
                                 null, column.getHeaderValue(), 
                                 false, false, 0, 0);
            headerWidth = comp.getPreferredSize().width;

            comp = table.getDefaultRenderer(model.getColumnClass(i)).
                             getTableCellRendererComponent(
							   table, longObject,
                                 false, false, 0, i);
            cellWidth = comp.getPreferredSize().width;

            column.setPreferredWidth(Math.max(headerWidth, cellWidth));
	    //	    column.setMinimumSize(column.getPreferredSize());
        }
    } 
    */

    public  void initColumnSizes(AbstractTableModel model) {
        TableColumn column = null;
        for (int i = 0; i < model.getColumnCount(); i++) {
            column = getColumnModel().getColumn(i);
	    column.sizeWidthToFit();
	}
	resizeAndRepaint();
    }
}
