/*
MultRelation : Handles Ratio generalizations
    Copyright (C) 2001 Gayatri Sathe

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package relax;

import diff.*;
import java.lang.*;
import util.*;
import cube.*;

class MultRelation implements Relation{
    String relation=new String("multiple");
    float multiple;
    float devR;	
    public MultRelation(float mul, float deviantR) {
	multiple = mul;
	devR = deviantR;
    }
    public void display() {
	System.out.println("rel="+relation+" mul="+multiple+" devR="+devR);
    }
    public float getMultiple() { return multiple; }
    public float deviantR() {return devR;}
    public void setSign(boolean less){}
    public void setMeasures(float f1, float f2){
	multiple=f2/f1;
    }
    public void setDiffParams(DiffParams diffPars){
	diffPars._alg = new RelaxKLDist(multiple); // error function for finding exceptions
	diffPars._ratio = multiple;
	diffPars._exhaustive=false;
    }
    
    public float[] getRS(float[] counts){
        counts[2] = Math.max(counts[2],0);
	return counts;
    }	
	
    public String Rfunc(String v1, String v2) {
//        R(T',T) = T(v1)*(T(r) - T'(r))*log(T(r)/T'(r)) 

	return "((NVL("+v2+","+v1+"*"+multiple+")"+"-"+multiple+"*NVL("+v1+","+v2+"/"+multiple+"))*ln(NVL("+v2+","+v1+"*"+multiple+")/greatest(("+multiple+"*NVL("+v1+",1)),1)))";
    }

    public String Sfunc(String v1, String v2){
//	S(Ts,T) = max(T(v1)Ts(r)log(devR)-R(Ts,T), 0)
 	
	return "(NVL("+v1+","+v2+"/"+multiple+")*"+multiple+"*ln("+devR+"))-"+Rfunc(v1,v2);
    }	
}
	


