/*
RelaxParams : Stores the user-specified parameters
    Copyright (C) 2001 Gayatri Sathe

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package relax;

import java.util.*;

public class RelaxParams {
    int _N = 10; //diff result size
    int _size = 10; //relax result size	
    boolean _debug = false;
    boolean _stats = false;
    Relation _rel;	
    int _maxR = 4;	
    float _devR = 1;	
    float _k = 1;
    boolean multipleSet = false;
    public int resultSize() {return _size;}
    public Relation getRel() {return _rel;}
    void setSign(boolean less) { _rel.setSign(less); }	
    void setMeasures(float f1, float f2) { 
	if (!multipleSet) _rel.setMeasures(f1,f2);
    }
    public float deviantR() {return _devR;}	
    public float get_k() {return _k;}	
    public boolean printStats() {return _stats;}
    public boolean debug() {return _debug; }

    public RelaxParams(String args) {
        boolean _isLessThan = false;
        String _relation= new String("boolean");
        float _multiple = (float)0.5;
	multipleSet = false;
	
	if (args == null) 
	    args = "";
	StringTokenizer tok = new StringTokenizer(args, ";");
	while (tok.hasMoreTokens()) {
	    String anArg = tok.nextToken();
	    if (anArg.startsWith("N=")) 
		_N = Integer.valueOf(anArg.substring(2)).intValue();
	
	    if (anArg.startsWith("NR="))
		_maxR = Integer.valueOf(anArg.substring(3)).intValue();

	    if (anArg.startsWith("size="))
	        _size = Integer.valueOf(anArg.substring(5)).intValue();
	    
	    if (anArg.startsWith("k="))
		_k = Float.valueOf(anArg.substring(2)).floatValue();

	    if (anArg.startsWith("rel=")) { // boolean or multiple
		_relation = anArg.substring(4);
		System.out.println(_relation);
	    }	
	    
	    if (anArg.startsWith("multiple=")) {
		_multiple= Float.valueOf(anArg.substring(9)).floatValue();
		multipleSet=true;
	    }	
	    
	    if (anArg.equalsIgnoreCase("less"))
		_isLessThan = true;

	    if (anArg.startsWith("devR=")) {
		_devR = Float.valueOf(anArg.substring(5)).floatValue();
		System.out.println("devR="+_devR);
	    }
	    if (anArg.equalsIgnoreCase("debug")) 
		_debug = true;

	    if (anArg.equalsIgnoreCase("stats"))
		_stats = true;
	}

	if (_relation.equals("multiple")) 
	    _rel = new MultRelation(_multiple,_devR);
	else 
	    _rel = new BoolRelation(_isLessThan,_k);
    }

};
