/*
ETerm : Term with 2 measure values
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;

public class ETerm extends Term {
    public double _v1 = 0;
    public double _v2 = 0;
    public int _cnt = 1;

    /*    public ETerm(int numCols) {
	super(numCols);
	} */
    public ETerm(TermDesc tdesc) {
	super(tdesc);

    }
    public ETerm(Term t) {
	super(t);
	initMeasures();
    }
    public void initMeasures() {
	_v1 = _v2 = 0;
	_cnt = 0;
    }
    public void setMeasures(double v1, double v2, int cnt) {
	_v1 = v1; _v2 = v2; _cnt = cnt;
    }
    public void setMeasures(double v1, double v2) {
	_v1 = v1; _v2 = v2; _cnt = 1;
    }
    public void copyMeasures(ETerm tup)
    {
	_v1 = tup._v1;
	_v2 = tup._v2;
	_cnt = tup._cnt;
    }
    public int count() {return _cnt;}
    public void copy(ETerm tup)
    {
	super.copy(tup);
	copyMeasures(tup);
    }
    public String toString() {
	return super.toString() + ", " + _v1 + ", " + _v2 + ", " + _cnt;
    }
    public float meas1() {return (float)_v1;}
    public float meas2() {return (float)_v2;}
    public double ratio() {
	return _v1/_v2;
    }
    
    double _err;
    public void setError(double err) {_err = err;}
    public double storedError() {return _err;}
};
