/*
MTerm : Extends Term to include the measure value of the cell
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;

public class MTerm extends Term {
    public float _meas = 0;
    public MTerm(TermDesc tdesc) {
	super(tdesc);
    }
    public MTerm(Term t) {
	super(t);
    }
    public MTerm(Term t, float m) {
	super(t);
	_meas = m;
    }
    public void copy(MTerm tup)
    {
	super.copy(tup);
	_meas = tup.measure();
    }
    public String toString() {
	return super.toString() + ", " + _meas;
    }
    public void setMeasure(float val) {_meas = val;}

    public float measure() {return (float)_meas;}
};
