/*
SqlQryGen : Generation of SQL queries  
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;
public class SqlQryGen {
    public static SqlString whereClause(Term t, boolean matchAgg) {
	SqlString names = new SqlString(" AND ");
	for (int i = 0; i < t.numAttrs(); i++) {
	    if (t.range(i)) continue;
	    if (!matchAgg && t.aggregated(i)) continue;
	    names.add("("+ t.desc(i).name() + " = " + t.val(i) + ")");
	}
	return names;
    }
    public static SqlString whereClause(String tcols[], Term t) { return whereClause(tcols,t,false,"");}
    public static SqlString whereClause(String tcols[], Term t, boolean matchAgg) {    return whereClause(tcols,t,matchAgg,"");}
    public static SqlString whereClause(String tcols[], Term t, boolean matchAgg, String prefix) {
	SqlString names = new SqlString(" AND ");
	for (int i = 0; i < tcols.length; i++) {
	    if (t.range(i)) continue;
	    if (!matchAgg && t.aggregated(i)) continue;
	    names.add("("+ prefix + tcols[i] + " = " + t.val(i) + ")");
	}
	return names;
    }
    public static SqlString groupList(String tcols[], Term t, String prefix) {
	SqlString names = new SqlString(", ");
	int size = (t == null)?tcols.length:t.numAttrs();
	for (int i = 0; i < size; i++) {
	    if ((t != null) && ! t.range(i)) continue;
	    if (tcols != null)
		names.add(prefix + tcols[i]);
	    else
		names.add(t.desc(i).name());
	}
	return names;
    }
    public static SqlString groupList(Term t) {
	return groupList(null, t, null);
    }
    public static String projectNames(TermDesc t) 
    {
	String names = "";
	for (int i = 0; i < t.size(); i++) {
	    if (names.length() > 0)
		names += ", ";
	    names += (t.desc(i).name());
	}
	if (names.length() > 0)
	    names += ", ";
	return names;
    }
    public static String projectNames(String[] tcols, Term t, String prefix, boolean appendComma) 
    {
	String names = "";
	int size = (t == null)?tcols.length:t.numAttrs();
	for (int i = 0; i < size; i++) {
	    if ((t != null) && ! t.range(i)) continue;
	    if (names.length() > 0)
		names += ", ";
	    if (tcols != null)
		names += (prefix + tcols[i] );
	    else
		names += (t.desc(i).name());
	}
	if (appendComma && (names.length() > 0))
	    names += ", ";
	return names;
    }
    public static String projectNames(Term t) 
    {
	return projectNames(null, t, null, true);
    }
};

